Index: trunk/VUT/OcclusionCullingSceneManager/TestCullingDotScene/TestCullingDotScene.vcproj
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/TestCullingDotScene/TestCullingDotScene.vcproj	(revision 37)
+++ trunk/VUT/OcclusionCullingSceneManager/TestCullingDotScene/TestCullingDotScene.vcproj	(revision 48)
@@ -129,9 +129,4 @@
 		</Filter>
 		<Filter
-			Name="Resource Files"
-			Filter="rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe;resx"
-			UniqueIdentifier="{67DA6AB6-F800-4c08-8B7A-83BB121AAD01}">
-		</Filter>
-		<Filter
 			Name="tinyxml"
 			Filter="">
Index: trunk/VUT/OcclusionCullingSceneManager/TestCullingTerrain/TestCullingTerrain.vcproj
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/TestCullingTerrain/TestCullingTerrain.vcproj	(revision 47)
+++ trunk/VUT/OcclusionCullingSceneManager/TestCullingTerrain/TestCullingTerrain.vcproj	(revision 48)
@@ -122,4 +122,7 @@
 			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}">
 			<File
+				RelativePath=".\TerrainContentGenerator.cpp">
+			</File>
+			<File
 				RelativePath=".\TestCullingTerrainApplication.cpp">
 			</File>
@@ -130,11 +133,9 @@
 			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}">
 			<File
+				RelativePath=".\TerrainContentGenerator.h">
+			</File>
+			<File
 				RelativePath=".\TestCullingTerrainApplication.h">
 			</File>
-		</Filter>
-		<Filter
-			Name="Resource Files"
-			Filter="rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe;resx"
-			UniqueIdentifier="{67DA6AB6-F800-4c08-8B7A-83BB121AAD01}">
 		</Filter>
 	</Files>
Index: trunk/VUT/OcclusionCullingSceneManager/TestCullingTerrain/TestCullingTerrainApplication.cpp
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/TestCullingTerrain/TestCullingTerrainApplication.cpp	(revision 47)
+++ trunk/VUT/OcclusionCullingSceneManager/TestCullingTerrain/TestCullingTerrainApplication.cpp	(revision 48)
@@ -1,5 +1,5 @@
 /**
     \file 
-        TestCullingApplication.cpp
+        TestCullingTerrainApplication.cpp
     \brief
         Tests the occlusion culling algorithm
@@ -14,5 +14,5 @@
 
 #include "Ogre.h"
-#include "TestCullingApplication.h"
+#include "TestCullingTerrainApplication.h"
 #include "OgreOcclusionCullingSceneTraverser.h"
 
@@ -23,12 +23,12 @@
 
 /***********************************************/
-/* TestCullingApplication implementation       */
+/* TestCullingTerrainApplication implementation       */
 /***********************************************/
-/*TestCullingApplication::~TestCullingApplication()
+/*TestCullingTerrainApplication::~TestCullingTerrainApplication()
 {
 	delete mRaySceneQuery;
 }*/
 //-----------------------------------------------------------------------
-void TestCullingApplication::createCamera( void )
+void TestCullingTerrainApplication::createCamera( void )
 {
 	// Create the camera
@@ -44,5 +44,5 @@
 }
 //-----------------------------------------------------------------------
-void TestCullingApplication::createScene(void)
+void TestCullingTerrainApplication::createScene(void)
 {
 	Plane waterPlane;
@@ -119,5 +119,5 @@
 }
 //-----------------------------------------------------------------------
-void TestCullingApplication::setupGui( void )
+void TestCullingTerrainApplication::setupGui( void )
 {
 	 mGUIRenderer = new CEGUI::OgreCEGUIRenderer(mWindow, Ogre::RENDER_QUEUE_OVERLAY, false, 3000, ST_EXTERIOR_CLOSE);
@@ -133,5 +133,5 @@
 }
 //-----------------------------------------------------------------------
-void TestCullingApplication::createFrameListener(void)
+void TestCullingTerrainApplication::createFrameListener(void)
 {
 	mFrameListener= new MouseQueryListener(mWindow, mCamera, mSceneMgr, mGUIRenderer);
@@ -140,5 +140,5 @@
 }
 //-----------------------------------------------------------------------
-void TestCullingApplication::chooseSceneManager(void)
+void TestCullingTerrainApplication::chooseSceneManager(void)
 {
     //mSceneMgr = mRoot->getSceneManager(ST_GENERIC);
@@ -395,5 +395,5 @@
 {
     // Create application object
-    TestCullingApplication app;
+    TestCullingTerrainApplication app;
 
 	try 
Index: trunk/VUT/OcclusionCullingSceneManager/TestCullingTerrain/TestCullingTerrainApplication.h
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/TestCullingTerrain/TestCullingTerrainApplication.h	(revision 47)
+++ trunk/VUT/OcclusionCullingSceneManager/TestCullingTerrain/TestCullingTerrainApplication.h	(revision 48)
@@ -1,5 +1,5 @@
 /**
     \file 
-        TestCullingApplication.h
+        TestCullingTerrainApplication.h
 */
 #include "CEGUIForwardRefs.h"
@@ -86,8 +86,8 @@
 
 
-class TestCullingApplication : public ExampleApplication
+class TestCullingTerrainApplication : public ExampleApplication
 {
 public:
-	//~TestCullingApplication();
+	//~TestCullingTerrainApplication();
 
 protected:
Index: trunk/VUT/OcclusionCullingSceneManager/include/OgreOcclusionCullingOctreeSceneManager.h
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/include/OgreOcclusionCullingOctreeSceneManager.h	(revision 46)
+++ trunk/VUT/OcclusionCullingSceneManager/include/OgreOcclusionCullingOctreeSceneManager.h	(revision 48)
@@ -1,9 +1,7 @@
-#ifndef _OcclusionCullingTerrainSceneManager_H__
-#define _OcclusionCullingTerrainSceneManager_H__
+#ifndef _OcclusionCullingOctreeSceneManager_H__
+#define _OcclusionCullingOctreeSceneManager_H__
 
 #include <OgreSceneNode.h>
 #include <OgreOctreeSceneManager.h>
-#include <OgreTerrainSceneManager.h>
-#include <OgreOctreeSceneQuery.h>
 #include <OgreOctreeNode.h>
 #include <OgreOctreeCamera.h>
@@ -11,5 +9,4 @@
 #include "OgrePrerequisites.h"
 #include "OgreOcclusionCullingOctreeSceneTraverser.h"
-//#include "OgreSolidHalfBoundingBox.h"
 
 using namespace std;
Index: trunk/VUT/OcclusionCullingSceneManager/include/OgreOcclusionCullingTerrainSceneManager.h
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/include/OgreOcclusionCullingTerrainSceneManager.h	(revision 45)
+++ trunk/VUT/OcclusionCullingSceneManager/include/OgreOcclusionCullingTerrainSceneManager.h	(revision 48)
@@ -10,6 +10,5 @@
 
 #include "OgrePrerequisites.h"
-#include "OgreOcclusionCullinOctreeSceneTraverser.h"
-//#include "OgreSolidHalfBoundingBox.h"
+#include "OgreOcclusionCullingOctreeSceneTraverser.h"
 
 using namespace std;
Index: trunk/VUT/OcclusionCullingSceneManager/src/OgreOcclusionCullingSceneManagerDll.cpp
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/src/OgreOcclusionCullingSceneManagerDll.cpp	(revision 45)
+++ trunk/VUT/OcclusionCullingSceneManager/src/OgreOcclusionCullingSceneManagerDll.cpp	(revision 48)
@@ -25,6 +25,6 @@
 
 #include "OgreOcclusionCullingTerrainSceneManager.h"
-#include "OgreOcclusionCullingSceneManager.h"
-#include "OgreOcclusionCullingDotSceneManager.h"
+#include "OgreOcclusionCullingOctreeSceneManager.h"
+//#include "OgreOcclusionCullingDotSceneManager.h"
 #include "OgreHeightmapTerrainPageSource.h"
 #include <OgreRoot.h>
Index: trunk/VUT/OcclusionCullingSceneManager/src/OgreOcclusionCullingOctreeSceneTraverser.cpp
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/src/OgreOcclusionCullingOctreeSceneTraverser.cpp	(revision 45)
+++ trunk/VUT/OcclusionCullingSceneManager/src/OgreOcclusionCullingOctreeSceneTraverser.cpp	(revision 48)
@@ -1,4 +1,4 @@
 #include "OgreOcclusionCullingOctreeSceneTraverser.h"
-#include "OgreOcclusionCullingTerrainSceneManager.h"
+#include "OgreOcclusionCullingOctreeSceneManager.h"
 #include "OgreHardwareOcclusionQuery.h"
 
@@ -7,10 +7,10 @@
 namespace Ogre {
 	//-----------------------------------------------------------------------
-	OcclusionCullingTerrainSceneTraverser::OcclusionCullingTerrainSceneTraverser(SceneManager *sm, RenderSystem *rsys): 
+	OcclusionCullingOctreeSceneTraverser::OcclusionCullingOctreeSceneTraverser(SceneManager *sm, RenderSystem *rsys): 
 	OcclusionCullingSceneTraverser(sm, rsys), mOctreeSceneRoot(0), mOctreeDistanceQueue(0)
 	{
 	}
 	//-----------------------------------------------------------------------
-	OcclusionCullingTerrainSceneTraverser::~OcclusionCullingTerrainSceneTraverser()
+	OcclusionCullingOctreeSceneTraverser::~OcclusionCullingOctreeSceneTraverser()
 	{		
 		if(mOctreeDistanceQueue)
@@ -18,5 +18,5 @@
 	}
 	//-----------------------------------------------------------------------
-	void OcclusionCullingTerrainSceneTraverser::traverseOctant(Camera *cam, Octree *octant )
+	void OcclusionCullingOctreeSceneTraverser::traverseOctant(Camera *cam, Octree *octant )
 	{
 		mNumTraversedNodes ++;
@@ -34,5 +34,5 @@
 	}
 	//-----------------------------------------------------------------------
-	void OcclusionCullingTerrainSceneTraverser::renderCullFrustum(Camera *cam)
+	void OcclusionCullingOctreeSceneTraverser::renderCullFrustum(Camera *cam)
 	{
 		AxisAlignedBox box;
@@ -63,5 +63,5 @@
 	//-----------------------------------------------------------------------
 	/** Renders the scene with the hierarchical stop and wait algorithm. */
-	void OcclusionCullingTerrainSceneTraverser::renderStopAndWait( Camera *cam )
+	void OcclusionCullingOctreeSceneTraverser::renderStopAndWait( Camera *cam )
 	{
 		AxisAlignedBox box;
@@ -114,5 +114,5 @@
 	//-----------------------------------------------------------------------
 	/** Renders the scene with the coherent hierarchical algorithm and the query queye. */
-	void OcclusionCullingTerrainSceneTraverser::renderCoherentWithQueue( Camera *cam )
+	void OcclusionCullingOctreeSceneTraverser::renderCoherentWithQueue( Camera *cam )
 	{
 		OctreeQueryQueue queryQueue;
@@ -204,5 +204,5 @@
 	}
 	//-----------------------------------------------------------------------
-	void OcclusionCullingTerrainSceneTraverser::pullUpVisibility( Camera *cam, Octree *octant )
+	void OcclusionCullingOctreeSceneTraverser::pullUpVisibility( Camera *cam, Octree *octant )
 	{
 		while(octant && !octant->isOctreeVisible())
@@ -216,5 +216,5 @@
 	}
 	//-----------------------------------------------------------------------
-	void OcclusionCullingTerrainSceneTraverser::renderOctant( Camera *cam, Octree *octant )
+	void OcclusionCullingOctreeSceneTraverser::renderOctant( Camera *cam, Octree *octant )
 	{
 		//if(octant->numNodes() > 0)
@@ -224,15 +224,15 @@
 
 			octant->setLastRendered(octant->lastVisited());
-			((OcclusionCullingTerrainSceneManager *)mSceneManager)->_renderOctant(cam, octant);
+			((OcclusionCullingOctreeSceneManager *)mSceneManager)->_renderOctant(cam, octant);
 		}
 		else OutputDebugString("already rendered");
 	}
 	//-----------------------------------------------------------------------
-	void OcclusionCullingTerrainSceneTraverser::setSceneRoot(Octree *root)
+	void OcclusionCullingOctreeSceneTraverser::setSceneRoot(Octree *root)
 	{
 		mOctreeSceneRoot = root;
 	}
 	//-----------------------------------------------------------------------
-	void OcclusionCullingTerrainSceneTraverser::initDistanceQueue(Camera *cam)
+	void OcclusionCullingOctreeSceneTraverser::initDistanceQueue(Camera *cam)
 	{
 		if(mOctreeDistanceQueue)
@@ -243,5 +243,5 @@
 	}
 	//-----------------------------------------------------------------------
-	bool OcclusionCullingTerrainSceneTraverser::isLeaf(Octree *octant)
+	bool OcclusionCullingOctreeSceneTraverser::isLeaf(Octree *octant)
 	{
 		for(int i=0; i<8; i++)
@@ -254,10 +254,10 @@
 	}
 	//-----------------------------------------------------------------------
-	void OcclusionCullingTerrainSceneTraverser::setNumOctreeNodes(unsigned int num)
+	void OcclusionCullingOctreeSceneTraverser::setNumOctreeNodes(unsigned int num)
 	{
 		mNumOctreeNodes = num;
 	}
 	//-----------------------------------------------------------------------
-	bool OcclusionCullingTerrainSceneTraverser::getOption( const String & key, void *val )
+	bool OcclusionCullingOctreeSceneTraverser::getOption( const String & key, void *val )
 	{
 		if ( key == "NumOctreeNodes" )
@@ -270,5 +270,5 @@
 	}
 	//-----------------------------------------------------------------------
-	bool OcclusionCullingTerrainSceneTraverser::getOptionKeys( StringVector & refKeys )
+	bool OcclusionCullingOctreeSceneTraverser::getOptionKeys( StringVector & refKeys )
 	{
 		refKeys.push_back( "NumOctreeNodes" );
Index: trunk/VUT/OcclusionCullingSceneManager/src/OgreOcclusionCullingTerrainSceneManager.cpp
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/src/OgreOcclusionCullingTerrainSceneManager.cpp	(revision 44)
+++ trunk/VUT/OcclusionCullingSceneManager/src/OgreOcclusionCullingTerrainSceneManager.cpp	(revision 48)
@@ -13,6 +13,6 @@
 	OcclusionCullingTerrainSceneManager::OcclusionCullingTerrainSceneManager()
 	{
-		mOcclusionCullingTerrainSceneTraverser = 
-			new OcclusionCullingTerrainSceneTraverser(this, mDestRenderSystem);
+		mOcclusionCullingOctreeSceneTraverser = 
+			new OcclusionCullingOctreeSceneTraverser(this, mDestRenderSystem);
 
 		//mDisplayNodes = true;
@@ -24,5 +24,5 @@
 	OcclusionCullingTerrainSceneManager::~OcclusionCullingTerrainSceneManager()
 	{
-		delete mOcclusionCullingTerrainSceneTraverser;
+		delete mOcclusionCullingOctreeSceneTraverser;
 	}
 	//-----------------------------------------------------------------------
@@ -43,6 +43,6 @@
 		setSpecialCaseRenderQueueMode(SceneManager::SCRQM_EXCLUDE);
 
-		mOcclusionCullingTerrainSceneTraverser->setSceneRoot(mOctree);
-		mOcclusionCullingTerrainSceneTraverser->renderScene(mCameraInProgress);
+		mOcclusionCullingOctreeSceneTraverser->setSceneRoot(mOctree);
+		mOcclusionCullingOctreeSceneTraverser->renderScene(mCameraInProgress);
 		
 		_deleteRenderedQueueGroups();
@@ -67,8 +67,8 @@
 		//mOcclusionCullingTerrainSceneTraverser->preprocess();
 
-     	mOcclusionCullingTerrainSceneTraverser->setNumSceneNodes((int)mSceneNodes.size());
-		mOcclusionCullingTerrainSceneTraverser->setRenderSystem(mDestRenderSystem);
+     	mOcclusionCullingOctreeSceneTraverser->setNumSceneNodes((int)mSceneNodes.size());
+		mOcclusionCullingOctreeSceneTraverser->setRenderSystem(mDestRenderSystem);
         
-		mOcclusionCullingTerrainSceneTraverser->setNumOctreeNodes(mNumOctreeNodes);
+		mOcclusionCullingOctreeSceneTraverser->setNumOctreeNodes(mNumOctreeNodes);
 
 		TerrainSceneManager::_updateSceneGraph(cam);
@@ -77,10 +77,10 @@
 	bool OcclusionCullingTerrainSceneManager::setOption( const String & key, const void * val )
 	{
-		return mOcclusionCullingTerrainSceneTraverser->setOption( key, val) || TerrainSceneManager::setOption( key, val );
+		return mOcclusionCullingOctreeSceneTraverser->setOption( key, val) || TerrainSceneManager::setOption( key, val );
 	}
 	//-----------------------------------------------------------------------
 	bool OcclusionCullingTerrainSceneManager::getOption( const String & key, void *val )
 	{
-		return mOcclusionCullingTerrainSceneTraverser->getOption( key, val) || TerrainSceneManager::getOption( key, val ) ;
+		return mOcclusionCullingOctreeSceneTraverser->getOption( key, val) || TerrainSceneManager::getOption( key, val ) ;
 	}
 	//-----------------------------------------------------------------------
@@ -92,5 +92,5 @@
 	bool OcclusionCullingTerrainSceneManager::getOptionKeys( StringVector & refKeys )
 	{
-		return mOcclusionCullingTerrainSceneTraverser->getOptionKeys ( refKeys ) || TerrainSceneManager::getOptionKeys( refKeys );
+		return mOcclusionCullingOctreeSceneTraverser->getOptionKeys ( refKeys ) || TerrainSceneManager::getOptionKeys( refKeys );
 	}
 	//-----------------------------------------------------------------------