Index: trunk/VUT/GtpVisibility/scripts/GtpVisibility.vcproj
===================================================================
--- trunk/VUT/GtpVisibility/scripts/GtpVisibility.vcproj	(revision 59)
+++ trunk/VUT/GtpVisibility/scripts/GtpVisibility.vcproj	(revision 64)
@@ -13,6 +13,6 @@
 		<Configuration
 			Name="Debug|Win32"
-			OutputDirectory="..\..\lib\$(ConfigurationName)"
-			IntermediateDirectory="..\..\obj\$(ConfigurationName)"
+			OutputDirectory="..\lib\$(ConfigurationName)"
+			IntermediateDirectory="..\obj\$(ConfigurationName)"
 			ConfigurationType="4"
 			CharacterSet="2">
Index: trunk/VUT/work/TestCullingDotScene/TestCullingDotScene.vcproj
===================================================================
--- trunk/VUT/work/TestCullingDotScene/TestCullingDotScene.vcproj	(revision 61)
+++ trunk/VUT/work/TestCullingDotScene/TestCullingDotScene.vcproj	(revision 64)
@@ -13,6 +13,6 @@
 		<Configuration
 			Name="Debug|Win32"
-			OutputDirectory="..\..\bin\$(ConfigurationName)"
-			IntermediateDirectory="..\..\obj\$(ConfigurationName)"
+			OutputDirectory=".\bin\$(ConfigurationName)"
+			IntermediateDirectory=".\obj\$(ConfigurationName)"
 			ConfigurationType="1"
 			CharacterSet="2">
Index: trunk/VUT/work/TestCullingTerrain/TestCullingTerrain.vcproj
===================================================================
--- trunk/VUT/work/TestCullingTerrain/TestCullingTerrain.vcproj	(revision 61)
+++ trunk/VUT/work/TestCullingTerrain/TestCullingTerrain.vcproj	(revision 64)
@@ -13,6 +13,6 @@
 		<Configuration
 			Name="Debug|Win32"
-			OutputDirectory="..\..\bin\$(ConfigurationName)"
-			IntermediateDirectory="..\..\obj\$(ConfigurationName)"
+			OutputDirectory=".\bin\$(ConfigurationName)"
+			IntermediateDirectory=".\obj\$(ConfigurationName)"
 			ConfigurationType="1"
 			CharacterSet="2"
Index: trunk/VUT/work/TestCulling/TestCulling.vcproj
===================================================================
--- trunk/VUT/work/TestCulling/TestCulling.vcproj	(revision 61)
+++ trunk/VUT/work/TestCulling/TestCulling.vcproj	(revision 64)
@@ -13,6 +13,6 @@
 		<Configuration
 			Name="Debug|Win32"
-			OutputDirectory="..\..\bin\$(ConfigurationName)"
-			IntermediateDirectory="..\..\obj\$(ConfigurationName)"
+			OutputDirectory=".\bin\$(ConfigurationName)"
+			IntermediateDirectory=".\obj\$(ConfigurationName)"
 			ConfigurationType="1"
 			CharacterSet="2"
Index: trunk/VUT/Ogre/scripts/Plugin_VisibilitySceneManager.vcproj
===================================================================
--- trunk/VUT/Ogre/scripts/Plugin_VisibilitySceneManager.vcproj	(revision 59)
+++ trunk/VUT/Ogre/scripts/Plugin_VisibilitySceneManager.vcproj	(revision 64)
@@ -13,6 +13,6 @@
 		<Configuration
 			Name="Debug|Win32"
-			OutputDirectory="..\..\bin\$(ConfigurationName)"
-			IntermediateDirectory="..\..\obj\$(ConfigurationName)"
+			OutputDirectory="..\bin\$(ConfigurationName)"
+			IntermediateDirectory="..\obj\$(ConfigurationName)"
 			ConfigurationType="2"
 			CharacterSet="2">
@@ -40,10 +40,10 @@
 				LinkIncremental="2"
 				SuppressStartupBanner="TRUE"
-				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Dependencies\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;$(OGRE_ADDONS_PATH)\dotsceneoctree\PlugIns\DotSceneManager\bin\debug&quot;;..\bin\debug;..\..\lib\debug"
+				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Dependencies\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;$(OGRE_ADDONS_PATH)\dotsceneoctree\PlugIns\DotSceneManager\bin\debug&quot;;..\lib\debug;..\..\lib\debug;..\..\GtpVisibility\lib\debug"
 				ModuleDefinitionFile="..\misc\OgreVisibilitySceneManager.def"
 				GenerateDebugInformation="TRUE"
 				ProgramDatabaseFile="$(OutDir)/Plugin_VisibilitySceneManager.pdb"
 				SubSystem="2"
-				ImportLibrary="$(OutDir)\Plugin_VisibilitySceneManager.lib"
+				ImportLibrary="$(OutDir)/Plugin_VisibilitySceneManager.lib"
 				TargetMachine="1"/>
 			<Tool